package response

import "time"

type ShoppingCart struct {
	ID        int64              `json:"id"`
	UserID    int64              `json:"user_id"`
	CreatedAt time.Time          `json:"created_at"`
	UpdatedAt *time.Time         `json:"updated_at"`
	Quantity  int64              `json:"quantity"` // 商品数量
	Items     []ShoppingCartItem `json:"items"`
}
type ShoppingCartItem struct {
	ID             int64      `json:"id"`
	ShoppingCartID int64      `json:"shopping_cart_id"`
	ProductID      int64      `json:"product_id"`
	Product        Product    `json:"product"`
	Quantity       int32      `json:"quantity"`
	TotalPrice     int64      `json:"total_price"`
	CreatedAt      time.Time  `json:"created_at"`
	UpdatedAt      *time.Time `json:"updated_at"`
}
