package category

import (
	"github.com/gin-gonic/gin"
	"go-micro.dev/v4/client"
	"sghgogs.com/micro/shopping-service-client/api/category"
	"sghgogs.com/micro/shopping-service-client/utils"
	"sghgogs.com/micro/shopping-service-client/utils/baseservice"
	pb "sghgogs.com/micro/shopping-service-service/proto"
)

type Category struct {
	*baseservice.BaseService
}

func NewCategoryRouter(namespace string, client client.Client) *Category {
	return &Category{
		BaseService: &baseservice.BaseService{
			Namespace: namespace,
			Client:    client,
		},
	}
}
func (svc *Category) RegisterRoutes(r *gin.Engine) {
	api := category.Category{}
	api.Namespace = svc.Namespace
	api.Service = pb.NewShoppingCategoryService(svc.Namespace, svc.Client)
	svc.registerCategoryRoutes(r, "/admin/v1/api", &api)
}
func (svc *Category) registerCategoryRoutes(r *gin.Engine, path string, api *category.Category) {
	v1 := r.Group(path).Use(utils.TokenAuthMiddleware())
	{
		v1.GET("/categorizes", api.GetCategoryList)
		v1.GET("/all_categorizes", api.GetAllCategories)
	}
}
