package upload

import (
	"github.com/gin-gonic/gin"
	"go-micro.dev/v4/client"
	"sghgogs.com/micro/shopping-service-client/api/upload"
	"sghgogs.com/micro/shopping-service-client/utils/baseservice"
	"sghgogs.com/micro/shopping-service-client/utils/miniohelper"
)

type Upload struct {
	*baseservice.BaseService
	MinioClient miniohelper.MinioClient
}

func NewUploadRouter(namespace string, client client.Client, minio miniohelper.MinioClient) *Upload {
	return &Upload{
		MinioClient: minio,
		BaseService: &baseservice.BaseService{
			Namespace: namespace,
			Client:    client,
		},
	}
}

func (svc *Upload) RegisterRoutes(r *gin.Engine) {
	api := upload.Upload{}
	api.Service = svc.MinioClient
	api.Namespace = svc.Namespace
	svc.registerUploadRoutes(r, "/admin/v1/api/upload", &api)
}

func (svc *Upload) registerUploadRoutes(r *gin.Engine, path string, api *upload.Upload) {
	v1 := r.Group(path)
	{
		v1.POST("/file/:file_type", api.UploadUserAvatar)
	}
}
