package miniohelper

import (
	"fmt"
	"log"
	"testing"
	"time"
)

func MinioInitTest() *MinioClient {
	endpoint := "127.0.0.1:9000"
	accessKey := "N7nb2yRoNtkbvq7l3xAv"
	secretKey := "FbJiQGN8xHLpddsjexDj274M06mKLfeB4rN9bqEQ"
	// useSSL := false
	client, err := NewMinioClient(endpoint, accessKey, secretKey)
	if err != nil {
		fmt.Println("err", err)
	}
	return client
}

func TestMinIOHelper(t *testing.T) {
	// client := MinioInitTest()
	// err := client.UploadFile("test", "text", "./text.txt")
	// if err != nil {
	// 	t.Error("upload file: ", err)
	// }
	// t.Run("TestInitializeMinioClient", TestInitializeMinioClient)
	// t.Run("TestUploadFile", TestUploadFile)
}
func TestName(t *testing.T) {
	fmt.Println(generateDynamicFilename("my.image.jpg.txt"))
}

// 生成动态截取后缀并拼接时间戳的文件名
// func generateDynamicFilename(filePath string) string {
// 	// 使用 filepath.Base 获取文件名
// 	fileName := filepath.Base(filePath)
//
// 	// 使用 strings.LastIndex 获取最后一个点的索引
// 	lastDotIndex := strings.LastIndex(fileName, ".")
//
// 	// 如果文件名中包含点，则截取后缀，否则使用原始文件名
// 	var prefix, suffix string
// 	if lastDotIndex != -1 {
// 		prefix = fileName[:lastDotIndex]
// 		suffix = fileName[lastDotIndex:]
// 	} else {
// 		prefix = fileName
// 		suffix = ""
// 	}
//
// 	// 使用时间戳作为文件名的前缀
// 	timestamp := time.Now().Format("20060102150405") // 格式化为yyyyMMddHHmmss
// 	return timestamp + "_" + prefix + suffix
// }

// 测试下载文件
func TestMinioDownloadFile(t *testing.T) {
	client := MinioInitTest()
	err := client.DownloadFile("test", "text", "./text.txt")
	if err != nil {
		t.Error("download file: ", err)
	}
}

// 测试列出bucket下所有的对象
func TestListObjects(t *testing.T) {
	client := MinioInitTest()
	objects, err := client.ListObjects("test", "")
	if err != nil {
		t.Error("list object: ", err)
	}
	log.Println("objects: ", objects)
}

// 删除对象
func TestDeleteFile(t *testing.T) {
	client := MinioInitTest()
	ret, err := client.DeleteFile("test", "text")
	if err != nil {
		t.Error("delete object: ", ret, err)
	}
	log.Println("delete object: ", ret)
}

// 获取对象，返回url,
func TestGetPresignedGetObject(t *testing.T) {
	client := MinioInitTest()
	object, err := client.GetPresignedGetObject("test", "user-avatar/20240119222405_头像专用图.png", 24*time.Hour)
	if err != nil {
		t.Error("GetPresignedGetObject: ", err)
	}
	log.Println("GetPresignedGetObject: ", object)
}
